<?php

include_once( "includes/pnHTML.php" );
include_once( "modules/ContentExpress/pnclass/CommonExpress.php" );

class pnCEHTML extends pnHTML
{
    /**
      * Properties
      */
    var $browser; // browser type
    var $os;      // operating system

    function pnCEHTML()
    {
        $this->pnHTML(); // initialize the super class attributes
        if(ereg("Konqueror", CommonExpress_getservvar("HTTP_USER_AGENT")))
            $this->browser = "Konqueror";
        elseif(ereg("Lynx", CommonExpress_getservvar("HTTP_USER_AGENT")))
            $this->browser = "Lynx";
        elseif(ereg("WebTV", CommonExpress_getservvar("HTTP_USER_AGENT")))
            $this->browser = "WebTV";
        elseif( (eregi("bot", CommonExpress_getservvar("HTTP_USER_AGENT"))) ||
                (ereg("Google", CommonExpress_getservvar("HTTP_USER_AGENT"))) ||
                (ereg("Slurp", CommonExpress_getservvar("HTTP_USER_AGENT"))) ||
                (ereg("Scooter", CommonExpress_getservvar("HTTP_USER_AGENT"))) ||
                (eregi("Spider", CommonExpress_getservvar("HTTP_USER_AGENT"))) ||
                (eregi("Infoseek", CommonExpress_getservvar("HTTP_USER_AGENT"))))
            $this->browser = "Bot";
        // Opera needs to be above MSIE as it pretends to be an MSIE clone
        elseif(ereg("Opera", CommonExpress_getservvar("HTTP_USER_AGENT")))
            $this->browser = "Opera";
        elseif(ereg("MSIE", CommonExpress_getservvar("HTTP_USER_AGENT")))
            $this->browser = "MSIE";
        else if(( (ereg("Nav", CommonExpress_getservvar("HTTP_USER_AGENT"))) ||
            (ereg("Gold", CommonExpress_getservvar("HTTP_USER_AGENT"))) ||
            (ereg("X11", CommonExpress_getservvar("HTTP_USER_AGENT"))) ||
            (ereg("Mozilla", CommonExpress_getservvar("HTTP_USER_AGENT"))) ||
            (ereg("Netscape", CommonExpress_getservvar("HTTP_USER_AGENT")))) &&
            (!ereg("MSIE", CommonExpress_getservvar("HTTP_USER_AGENT"))) &&
            (!ereg("Konqueror", CommonExpress_getservvar("HTTP_USER_AGENT"))))
            $this->browser = "Netscape";
        else
            $this->browser = "Other";

        if( ereg("Win", CommonExpress_getservvar("HTTP_USER_AGENT")))
            $this->os = "Windows";
        elseif( (ereg("Mac", CommonExpress_getservvar("HTTP_USER_AGENT"))) ||
                (ereg("PPC", CommonExpress_getservvar("HTTP_USER_AGENT"))))
            $this->os = "Mac";
        elseif(ereg("Linux", CommonExpress_getservvar("HTTP_USER_AGENT")))
            $this->os = "Linux";
        elseif(ereg("FreeBSD", CommonExpress_getservvar("HTTP_USER_AGENT")))
            $this->os = "FreeBSD";
        elseif(ereg("SunOS", CommonExpress_getservvar("HTTP_USER_AGENT")))
            $this->os = "SunOS";
        elseif(ereg("IRIX", CommonExpress_getservvar("HTTP_USER_AGENT")))
            $this->os = "IRIX";
        elseif(ereg("BeOS", CommonExpress_getservvar("HTTP_USER_AGENT")))
            $this->os = "BeOS";
        elseif(ereg("OS/2", CommonExpress_getservvar("HTTP_USER_AGENT")))
            $this->os = "OS/2";
        elseif(ereg("AIX", CommonExpress_getservvar("HTTP_USER_AGENT")))
            $this->os = "AIX";
        else
            $this->os = "Other";
    }

    // Thanks to Lars Berntzon provide this fix for Mozilla 0.9.9 user.
    // On the other hand, this function may be removed in the future depends
    // whether this function is included into pnHTML.php of the Postnuke core.
    function makeHiddenParams(&$action)
    {
      $col = explode("?", $action);
      $action = $col[0];
      $params = explode("&", $col[1]);
      $ret = array();
      foreach($params as $p) {
          $col = explode("=", $p);
          $ret[] = $col;
      }
      return $ret;
    }
 
    function CEFormStart( $action, $form_name = "", $input_names = "")
    {
    	$params = $this->makeHiddenParams($action);
        if ( $input_names != "")
        {
            $out .= '<form';
            $out .= ' name="'.pnVarPrepForDisplay($form_name).'"';
            $out .= ' action="'.pnVarPrepForDisplay($action).'"';
            $out .= ' method="post"';
            $out .= ' enctype="'.((empty ($this->fileupload)) ? 'application/x-www-form-urlencoded' : 'multipart/form-data').'"';
            $out .= " onsubmit='";
           
            $input_names_list = explode( ",", $input_names );

            include_once("modules/ContentExpress/pneditor/".pnModGetVar('ContentExpress','enable_wysiwyg')."/PluggableEditor.php");
            PluggableEditor_FormStart( $out, $form_name, $input_names_list );
            $out .= "; return validate_form();'>";
        }
        else
        {
            $out = '<form'
                .' name="'.pnVarPrepForDisplay($form_name).'"' 
                .' action="'.pnVarPrepForDisplay($action).'"'
                .' method="post"'
                .' enctype="'.((empty ($this->fileupload)) ? 'application/x-www-form-urlencoded' : 'multipart/form-data').'"'
		.' onsubmit="return validate_form();"'
                .'>'
            ;
        }

	foreach($params as $p) {
	    $out .= '<input type="hidden" name="' . pnVarPrepForDisplay($p[0]) . '" value="' . pnVarPrepForDisplay($p[1]) . '"/>';
	}

        if ($this->GetOutputMode() == _PNH_RETURNOUTPUT)
        {
            return $out;
        } else {
            $this->output .= $out;
        }
    }

    function CEFormTextArea($fieldname, $contents='', $rows=10, $cols=60, $wrap='soft', $accesskey='')
    {
        if (empty ($fieldname))
        {
            return;
        }
        if( $this->IsWYSIWYGAble() )
        {
            include_once("modules/ContentExpress/pneditor/".pnModGetVar('ContentExpress','enable_wysiwyg')."/PluggableEditor.php");
            PluggableEditor_FormTextArea( $output, $fieldname, $contents, $rows, $cols, $wrap, $accesskey );
        } else {
            return $this->FormTextArea( $fieldname, $contents, $rows, $cols, $wrap, $accesskey );
        }
        if ($this->GetOutputMode() == _PNH_RETURNOUTPUT)
        {
            return $output;
        } else {
            $this->output .= $output;
        }
    }

    function CEFormEnd()
    {
        return $this->FormEnd();
    }

    /**
     * Add HTML tags for a select field as part of a form.
     *
     * @access public
     * @since 1.13 - 2002/01/23
     * @param string $fieldname the name of the select field
     * @param array $data an array containing the data for the list.  Each array
     * entry is itself an array, containing the values for <code>'id'</code>
     * (the value returned if the entry is selected), <code>'name'</code>
     * (the string displayed for this entry) and <code>'selected'</code>
     * (optional, <code>1</code> if this option is selected)
     * @param integer $multiple (optional) <code>1</code> if the user is allowed to
     * make multiple selections
     * @param integer $size (optional) the number of entries that are visible in the
     * select at any one time.  Note that if the number
     * of actual items is less than this value then the select box will
     * shrink automatically to the correct size
     * @param string $selected (optional) selected value of <code>id</code>
     * @param string $accesskey (optional) accesskey to active this item
     * @param string $eventHandling (optional) event handling of Select element
     * @return string An HTML string if <code>ReturnHTML()</code> has been called,
     * otherwise null
     */
    function FormSelectMultiple($fieldname, $data, $multiple=0, $size=1, $selected = '', $accesskey='', $eventHandling= '')
    {
        if (empty ($fieldname))
        {
            return;
        }
        $this->tabindex++;

        // Set up selected if required
        if (!empty($selected)) {
            for ($i=0; !empty($data[$i]); $i++) {
                if ($data[$i]['id'] == $selected) {
                    $data[$i]['selected'] = 1;
                }
            }
        }

        $c = count($data);
        if ($c < $size)
        {
            $size = $c;
        }
        $output = '<select'
            .' name="'.pnVarPrepForDisplay($fieldname).'"'
            .' id="'.pnVarPrepForDisplay($fieldname).'"'
            .' size="'.pnVarPrepForDisplay($size).'"'
            .(($multiple == 1) ? ' multiple="multiple"' : '')
            .((empty ($accesskey)) ? '' : ' accesskey="'.pnVarPrepForDisplay($accesskey).'"')
            .' tabindex="'.$this->tabindex.'"'
            .((empty ($eventHandling)) ? '' : ' '.$eventHandling) 
            .'>'
        ;
        if( $c > 0 ) {
            foreach ($data as $datum)
            {
                $output .= '<option'
                    .' value="'.pnVarPrepForDisplay($datum['id']).'"'
                    .((empty ($datum['selected'])) ? '' : ' selected="selected"')
                    .'>'
                    .pnVarPrepForDisplay($datum['name'])
                    .'</option>'
                ;
            }
        }
        $output .= '</select>';
        if ($this->GetOutputMode() == _PNH_RETURNOUTPUT)
        {
            return $output;
        } else {
            $this->output .= $output;
        }
    }

    function IsWYSIWYGAble() {
        return $this->browser == "MSIE" && $this->os == "Windows";
    }

    function URL($url, $text, $image = false, $newwindow = false)
    {
        if( empty( $url ))
        {
            return;
        }

        if( $newwindow ) {
            $output = '<a href="'.$url.'" class="pn-normal" target="_blank">';
        } else {
            $output = '<a href="'.$url.'" class="pn-normal">';
        }
        if( !empty( $text ))
        {
            if ( !$image && $this->GetInputMode() == _PNH_PARSEINPUT)
            {
                $text = pnVarPrepForDisplay($text);
            }
            $output .= $text;
        }
        $output .= '</a>';

        if( $this->GetOutputMode() == _PNH_RETURNOUTPUT )
        {
            return $output;
        } else {
            $this->output .= $output;
        }
    }
}

?>
